OGRE-Next: Ogre::EllipsoidEmitter Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::EllipsoidEmitter Class Reference

Particle emitter which emits particles randomly from points inside an ellipsoid. More...

`#include <OgreEllipsoidEmitter.h>`

Inheritance diagram for Ogre::EllipsoidEmitter:
[legend]

## Public Member Functions
| EllipsoidEmitter (ParticleSystem *psys)
| See AreaEmitter.
void | _initParticle (Particle *pParticle) override
| See ParticleEmitter.
Public Member Functions inherited from Ogre::AreaEmitter
| AreaEmitter (ParticleSystem *psys)
unsigned short | _getEmissionCount (Real timeElapsed) override
| See ParticleEmitter.
Real | getDepth () const
| Gets the depth (local y size) of the emitter.
Real | getHeight () const
| Gets the height (local y size) of the emitter.
Real | getWidth () const
| Gets the width (local x size) of the emitter.
void | setDepth (Real Depth)
| Sets the depth (local y size) of the emitter.
void | setDirection (const Vector3 &direction) override
| Overloaded to update the trans.
void | setHeight (Real Height)
| Sets the height (local y size) of the emitter.
void | setSize (const Vector3 &size)
| Sets the size of the area from which particles are emitted.
void | setSize (Real x, Real y, Real z)
| Sets the size of the area from which particles are emitted.
void | setWidth (Real width)
| Sets the width (local x size) of the emitter.
Public Member Functions inherited from Ogre::ParticleEmitter
| ParticleEmitter (ParticleSystem *psys)
virtual | ~ParticleEmitter ()
| Virtual destructor essential.
virtual const Radian & | getAngle () const
| Returns the maximum angle which the initial particle direction can deviate from the emitters base direction.
virtual const ColourValue & | getColour () const
| Gets the colour of particles to be emitted.
virtual const ColourValue & | getColourRangeEnd () const
| Gets the maximum colour of particles to be emitted.
virtual const ColourValue & | getColourRangeStart () const
| Gets the minimum colour of particles to be emitted.
virtual const Vector3 & | getDirection () const
| Returns the base direction of the emitter.
virtual const Vector3 & | getDirPositionReference () const
| Returns the position reference to generate direction of emitted particles.
virtual bool | getDirPositionReferenceEnabled () const
| Returns whether direction or position reference is used.
virtual Real | getDuration () const
| Gets the duration of the emitter from when it is created or re-enabled.
virtual Real | getEmissionRate () const
| Returns the emission rate set for this emitter.
const String & | getEmittedEmitter () const
| Returns the name of the emitter to be emitted.
virtual bool | getEnabled () const
| Gets the flag indicating if this emitter is enabled or not.
virtual Real | getMaxDuration () const
| Gets the maximum duration of this emitter in seconds (see setDuration for more details).
virtual Real | getMaxParticleVelocity () const
| Returns the maximum particle velocity.
virtual Real | getMaxRepeatDelay () const
| Gets the maximum duration of this emitter in seconds (see setRepeatDelay for more details).
virtual Real | getMaxTimeToLive () const
| Gets the maximum time each particle will live for.
virtual Real | getMinDuration () const
| Gets the minimum duration of this emitter in seconds (see setDuration for more details).
virtual Real | getMinParticleVelocity () const
| Returns the minimum particle velocity.
virtual Real | getMinRepeatDelay () const
| Gets the minimum duration of this emitter in seconds (see setRepeatDelay for more details).
virtual Real | getMinTimeToLive () const
| Gets the minimum time each particle will live for.
const String & | getName () const
| Returns the name of the emitter.
virtual Real | getParticleVelocity () const
| Returns the initial velocity of particles emitted.
virtual const Vector3 & | getPosition () const
| Returns the position of this emitter relative to the center of the particle system.
virtual Real | getRepeatDelay () const
| Gets the duration of the emitter from when it is created or re-enabled.
virtual Real | getStartTime () const
| Gets the start time of the emitter.
virtual Real | getTimeToLive () const
| Gets the time each particle will live for.
const String & | getType () const
| Returns the name of the type of emitter.
virtual const Vector3 & | getUp () const
| Returns the up vector of the emitter.
virtual bool | isEmitted () const
| Return true if the emitter is emitted by another emitter.
virtual void | setAngle (const Radian &angle)
| Sets the maximum angle away from the emitter direction which particle will be emitted.
virtual void | setColour (const ColourValue &colour)
| Sets the initial colour of particles emitted.
virtual void | setColour (const ColourValue &colourStart, const ColourValue &colourEnd)
| Sets the range of colours for emitted particles.
virtual void | setColourRangeEnd (const ColourValue &colour)
| Sets the maximum colour of particles to be emitted.
virtual void | setColourRangeStart (const ColourValue &colour)
| Sets the minimum colour of particles to be emitted.
virtual void | setDirPositionReference (const Vector3 &position, bool enable)
| Sets the direction of the emitter.
virtual void | setDuration (Real duration)
| Sets the duration of the emitter.
virtual void | setDuration (Real min, Real max)
| Sets the range of random duration for this emitter.
virtual void | setEmissionRate (Real particlesPerSecond)
| Sets the emission rate for this emitter.
virtual void | setEmitted (bool emitted)
| Set the indication (true/false) to indicate that the emitter is emitted by another emitter.
virtual void | setEmittedEmitter (const String &emittedEmitter)
| Sets the name of the emitter to be emitted.
virtual void | setEnabled (bool enabled)
| Sets whether or not the emitter is enabled.
virtual void | setMaxDuration (Real max)
| Sets the maximum duration of this emitter in seconds (see setDuration for more details).
virtual void | setMaxParticleVelocity (Real max)
| Returns the maximum particle velocity.
virtual void | setMaxRepeatDelay (Real max)
| Sets the maximum duration of this emitter in seconds (see setRepeatDelay for more details).
virtual void | setMaxTimeToLive (Real max)
| Sets the maximum time each particle will live for.
virtual void | setMinDuration (Real min)
| Sets the minimum duration of this emitter in seconds (see setDuration for more details).
virtual void | setMinParticleVelocity (Real min)
| Returns the minimum particle velocity.
virtual void | setMinRepeatDelay (Real min)
| Sets the minimum duration of this emitter in seconds (see setRepeatDelay for more details).
virtual void | setMinTimeToLive (Real min)
| Sets the minimum time each particle will live for.
virtual void | setName (const String &newName)
| Sets the name of the emitter.
virtual void | setParticleVelocity (Real min, Real max)
| Sets the initial velocity range of particles emitted.
virtual void | setParticleVelocity (Real speed)
| Sets the initial velocity of particles emitted.
virtual void | setPosition (const Vector3 &pos)
| Sets the position of this emitter relative to the particle system center.
virtual void | setRepeatDelay (Real duration)
| Sets the time between repeats of the emitter.
virtual void | setRepeatDelay (Real min, Real max)
| Sets the range of random duration for this emitter.
virtual void | setStartTime (Real startTime)
| Sets the 'start time' of this emitter.
virtual void | setTimeToLive (Real minTtl, Real maxTtl)
| Sets the range of lifetime for particles emitted.
virtual void | setTimeToLive (Real ttl)
| Sets the lifetime of all particles emitted.
virtual void | setUp (const Vector3 &up)
| Sets the notional up vector of the emitter.
Public Member Functions inherited from Ogre::StringInterface
| StringInterface ()
virtual | ~StringInterface ()
| Virtual destructor, see Effective C++.
virtual void | copyParametersTo (StringInterface *dest) const
| Method for copying this object's parameters to another object.
ParamDictionary * | getParamDictionary ()
| Retrieves the parameter dictionary for this class.
const ParamDictionary * | getParamDictionary () const
virtual String | getParameter (const String &name) const
| Generic parameter retrieval method.
const ParameterList & | getParameters () const
| Retrieves a list of parameters valid for this object.
virtual bool | setParameter (const String &name, const String &value)
| Generic parameter setting method.
virtual void | setParameterList (const NameValuePairList &paramList)
| Generic multiple parameter setting method.
Public Member Functions inherited from Ogre::Particle
| Particle ()
void | _notifyOwner (ParticleSystem *owner)
| Internal method for notifying the particle of it's owner.
void | _notifyVisualData (ParticleVisualData *vis)
| Internal method for notifying the particle of it's optional visual data.
Real | getOwnHeight () const
| Retrieves the particle's personal width, if hasOwnDimensions is true.
Real | getOwnWidth () const
| Retrieves the particle's personal width, if hasOwnDimensions is true.
const Radian & | getRotation () const
ParticleVisualData * | getVisualData () const
| Get the optional visual data associated with the class.
bool | hasOwnDimensions () const
| Returns true if this particle deviates from the ParticleSystem's default dimensions (i.e.
void | resetDimensions ()
| Utility method to reset this particle.
void | setDimensions (Real width, Real height)
| Sets the width and height for this particle.
void | setRotation (const Radian &rad)
| Sets the current rotation.

## Additional Inherited Members
Public Types inherited from Ogre::Particle
enum | ParticleType { Visual , Emitter }
| Type of particle. More...
Static Public Member Functions inherited from Ogre::StringInterface
static void | cleanupDictionary ()
| Cleans up the static 'msDictionary' required to reset Ogre, otherwise the containers are left with invalid pointers, which will lead to a crash as soon as one of the ResourceManager implementers (e.g.
Public Attributes inherited from Ogre::Particle
ColourValue | mColour
| Current colour.
Vector3 | mDirection
| Direction (and speed).
Real | mHeight
| Personal height if mOwnDimensions == true.
bool | mOwnDimensions
| Does this particle have it's own dimensions?
ParticleType | mParticleType
| Determines the type of particle.
Vector3 | mPosition
| World position.
Radian | mRotation
| Current rotation value.
Radian | mRotationSpeed
| Speed of rotation in radians/sec.
Real | mTimeToLive
| Time to live, number of seconds left of particles natural life.
Real | mTotalTimeToLive
| Total Time to live, number of seconds of particles natural life.
Real | mWidth
| Personal width if mOwnDimensions == true.

## Detailed Description

Particle emitter which emits particles randomly from points inside an ellipsoid.

Remarks
  This basic particle emitter emits particles from a ellipsoid area. The initial direction of these particles can either be a single direction (i.e. a line), a random scattering inside a cone, or a random scattering in all directions, depending the 'angle' parameter, which is the angle across which to scatter the particles either side of the base direction of the emitter.

## Constructor & Destructor Documentation

## ◆ EllipsoidEmitter()

Ogre::EllipsoidEmitter::EllipsoidEmitter | ( | ParticleSystem * | psys | ) |

See AreaEmitter.

## Member Function Documentation

## ◆ _initParticle()

void Ogre::EllipsoidEmitter::_initParticle | ( | Particle * | pParticle | ) |
| overridevirtual

See ParticleEmitter.

Reimplemented from Ogre::ParticleEmitter.

Reimplemented in Ogre::HollowEllipsoidEmitter.

The documentation for this class was generated from the following file:

- OgreEllipsoidEmitter.h